> For the complete documentation index, see [llms.txt](https://docs.umbraco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.umbraco.com/umbraco-heartcore/api-documentation/content-management/content/type.md).

# Content Types

**BASE URL**: `https://api.umbraco.io`

## Table of Contents

* [Common Headers](#common-headers)
* [Authentication](#authentication)
* [Errors](#errors)
* [Get all Content Types](#get-all-content-types)
* [Get by alias](#get-by-alias)

## Common Headers

```http
Api-Version: 2
Umb-Project-Alias: {project-alias}
```

## Authentication

Authentication is required for this API. You must supply a Bearer Token via an Authorization header or an API Key through an Authorization or Api-Key header.

## Errors

If an error occurs you will receive a HTTP status code along with an API error code and an error message in the response body.

| Status Code | Error Code          | Message                                               |
| ----------- | ------------------- | ----------------------------------------------------- |
| 401         | Unauthorized        | Authorization has been denied for this request.       |
| 403         | Forbidden           | You are not authorized to access the given resource.  |
| 404         | NotFound            | Content Type with alias '{alias}' could not be found. |
| 500         | InternalServerError | Internal server error.                                |

**JSON example**:

```json
{
  "error": {
    "code": "Forbidden",
    "message": "Authorization has been denied for this request."
  }
}
```

## Get all Content Types

Get a list of all available Content Types.

**URL**: `/content/type`

**Method**: `GET`

**Permissions required** : Access to Settings section of the Umbraco Backoffice

### Success Response

**Code**: 200

**Content Example**:

```json
{
    "_links": {
        "self": {
            "href": "https://api.umbraco.io/content/type"
        },
        "contenttypes": [
            {
                "href": "https://api.umbraco.io/content/type/contentBase"
            },
            {
                "href": "https://api.umbraco.io/content/type/feature"
            },
            {
                "href": "https://api.umbraco.io/content/type/navigationBase"
            },
            {
                "href": "https://api.umbraco.io/content/type/home"
            },
            {
                "href": "https://api.umbraco.io/content/type/blog"
            },
            {
                "href": "https://api.umbraco.io/content/type/blogpost"
            },
            {
                "href": "https://api.umbraco.io/content/type/products"
            },
            {
                "href": "https://api.umbraco.io/content/type/product"
            }
        ]
    },
    "_embedded": {
        "contenttypes": [
            {
                "allowCultureVariant": false,
                "alias": "blog",
                "compositions": [
                    "contentBase",
                    "navigationBase"
                ],
                "groups": [
                    {
                        "name": "Content",
                        "sortOrder": 10,
                        "properties": [
                            {
                                "allowCultureVariant": false,
                                "alias": "pageTitle",
                                "label": "Page Title",
                                "propertyEditorAlias": "Umbraco.TextBox",
                                "sortOrder": 0,
                                "validation": {
                                    "required": false
                                }
                            },
                            {
                                "allowCultureVariant": false,
                                "alias": "bodyText",
                                "configuration": {
                                    "editor": null,
                                    "blocks": null,
                                    "useLiveEditing": false,
                                    "overlaySize": null,
                                    "hideLabel": false,
                                    "mediaParentId": null,
                                    "ignoreUserStartNodes": false
                                },
                                "label": "Content",
                                "propertyEditorAlias": "Umbraco.TinyMCE",
                                "sortOrder": 1,
                                "validation": {
                                    "required": false
                                }
                            }
                        ]
                    },
                    {
                        "name": "Navigation & SEO",
                        "sortOrder": 20,
                        "properties": [
                            {
                                "allowCultureVariant": false,
                                "alias": "seoMetaDescription",
                                "label": "Description",
                                "propertyEditorAlias": "Umbraco.TextArea",
                                "sortOrder": 0,
                                "validation": {
                                    "required": false
                                }
                            },
                            {
                                "allowCultureVariant": false,
                                "alias": "keywords",
                                "configuration": {
                                    "group": "default",
                                    "storageType": "Json",
                                    "Delimiter": "\u0000"
                                },
                                "label": "Keywords",
                                "propertyEditorAlias": "Umbraco.Tags",
                                "sortOrder": 1,
                                "validation": {
                                    "required": false
                                }
                            },
                            {
                                "allowCultureVariant": false,
                                "alias": "umbNaviHide",
                                "configuration": {
                                    "default": false,
                                    "showLabels": false,
                                    "labelOn": null,
                                    "labelOff": null
                                },
                                "label": "Hide in Navigation",
                                "propertyEditorAlias": "Umbraco.TrueFalse",
                                "sortOrder": 2,
                                "validation": {
                                    "required": false
                                }
                            }
                        ]
                    },
                    {
                        "name": "Settings",
                        "sortOrder": 0,
                        "properties": [
                            {
                                "allowCultureVariant": false,
                                "alias": "howManyPostsShouldBeShown",
                                "configuration": {
                                    "enableRange": false,
                                    "initVal1": 10.0,
                                    "initVal2": 0.0,
                                    "minVal": 1.0,
                                    "maxVal": 50.0,
                                    "step": 1.0
                                },
                                "label": "How many posts should be shown?",
                                "propertyEditorAlias": "Umbraco.Slider",
                                "sortOrder": 0,
                                "validation": {
                                    "required": false
                                }
                            },
                            {
                                "allowCultureVariant": false,
                                "alias": "disqusShortname",
                                "description": "To use comments, you'll need to sign up for Disqus and enter your shortname here (more info: https://help.disqus.com/customer/portal/articles/472097-universal-embed-code)",
                                "label": "Disqus Shortname",
                                "propertyEditorAlias": "Umbraco.TextBox",
                                "sortOrder": 1,
                                "validation": {
                                    "required": false
                                }
                            }
                        ]
                    }
                ],
                "name": "Blog",
                "_createDate": "2019-10-04T11:04:28.35Z",
                "_id": "558f0270-76dc-4b81-bd4b-0687eecce904",
                "_updateDate": "2019-10-04T11:04:28.35Z",
                "_links": {
                    "self": {
                        "href": "https://api.umbraco.io/content/type/blog"
                    },
                    "root": {
                        "href": "https://api.umbraco.io/content/type"
                    }
                }
            },
            {
                "allowCultureVariant": false,
                "alias": "blogpost",
                "compositions": [
                    "navigationBase"
                ],
                "groups": [
                    {
                        "name": "Navigation & SEO",
                        "sortOrder": 20,
                        "properties": [
                            {
                                "allowCultureVariant": false,
                                "alias": "seoMetaDescription",
                                "label": "Description",
                                "propertyEditorAlias": "Umbraco.TextArea",
                                "sortOrder": 0,
                                "validation": {
                                    "required": false
                                }
                            },
                            {
                                "allowCultureVariant": false,
                                "alias": "keywords",
                                "configuration": {
                                    "group": "default",
                                    "storageType": "Json",
                                    "Delimiter": "\u0000"
                                },
                                "label": "Keywords",
                                "propertyEditorAlias": "Umbraco.Tags",
                                "sortOrder": 1,
                                "validation": {
                                    "required": false
                                }
                            },
                            {
                                "allowCultureVariant": false,
                                "alias": "umbNaviHide",
                                "configuration": {
                                    "default": false,
                                    "showLabels": false,
                                    "labelOn": null,
                                    "labelOff": null
                                },
                                "label": "Hide in Navigation",
                                "propertyEditorAlias": "Umbraco.TrueFalse",
                                "sortOrder": 2,
                                "validation": {
                                    "required": false
                                }
                            }
                        ]
                    },
                    {
                        "name": "Content",
                        "sortOrder": 0,
                        "properties": [
                            {
                                "allowCultureVariant": false,
                                "alias": "pageTitle",
                                "label": "Page Title",
                                "propertyEditorAlias": "Umbraco.TextBox",
                                "sortOrder": 0,
                                "validation": {
                                    "required": true
                                }
                            },
                            {
                                "allowCultureVariant": false,
                                "alias": "categories",
                                "configuration": {
                                    "group": "default",
                                    "storageType": "Json",
                                    "Delimiter": "\u0000"
                                },
                                "label": "Categories (tags)",
                                "propertyEditorAlias": "Umbraco.Tags",
                                "sortOrder": 1,
                                "validation": {
                                    "required": false
                                }
                            },
                            {
                                "allowCultureVariant": false,
                                "alias": "excerpt",
                                "label": "Excerpt",
                                "propertyEditorAlias": "Umbraco.TextArea",
                                "sortOrder": 2,
                                "validation": {
                                    "required": true
                                }
                            },
                            {
                                "allowCultureVariant": false,
                                "alias": "bodyText",
                                "configuration": {
                                    "editor": null,
                                    "blocks": null,
                                    "useLiveEditing": false,
                                    "overlaySize": null,
                                    "hideLabel": false,
                                    "mediaParentId": null,
                                    "ignoreUserStartNodes": false
                                },
                                "label": "Content",
                                "propertyEditorAlias": "Umbraco.TinyMCE",
                                "sortOrder": 3,
                                "validation": {
                                    "required": false
                                }
                            }
                        ]
                    }
                ],
                "name": "Blogpost",
                "_createDate": "2019-10-04T11:10:04.247Z",
                "_id": "5cb405d5-cb5e-4408-8117-f0ac51fcf524",
                "_updateDate": "2019-10-04T11:10:04.247Z",
                "_links": {
                    "self": {
                        "href": "https://api.umbraco.io/content/type/blogpost"
                    },
                    "root": {
                        "href": "https://api.umbraco.io/content/type"
                    }
                }
            }
        ]
    }
}
```

## Get by alias

Get a specific Content Type by its alias.

**URL**: `/content/type/{alias}`

**Method**: `GET`

**Permissions required** : Access to Settings section of the Umbraco Backoffice

### Success Response

**Code**: 200

**Content Example**:

```json
{
    "allowCultureVariant": false,
    "alias": "home",
    "compositions": [],
    "groups": [
        {
            "name": "Hero",
            "sortOrder": 0,
            "properties": [
                {
                    "allowCultureVariant": false,
                    "alias": "heroHeader",
                    "description": "This is the main headline for the hero area on the Homepage",
                    "label": "Header",
                    "propertyEditorAlias": "Umbraco.TextBox",
                    "sortOrder": 0,
                    "validation": {
                        "required": true
                    }
                },
                {
                    "allowCultureVariant": false,
                    "alias": "heroDescription",
                    "label": "Description",
                    "propertyEditorAlias": "Umbraco.TextArea",
                    "sortOrder": 1,
                    "validation": {
                        "required": true
                    }
                },
                {
                    "allowCultureVariant": false,
                    "alias": "heroCTACaption",
                    "label": "Call to Action Caption",
                    "propertyEditorAlias": "Umbraco.TextBox",
                    "sortOrder": 2,
                    "validation": {
                        "required": true
                    }
                },
                {
                    "allowCultureVariant": false,
                    "alias": "heroCTALink",
                    "label": "Call to Action Link",
                    "propertyEditorAlias": "Umbraco.ContentPicker",
                    "sortOrder": 3,
                    "validation": {
                        "required": false
                    }
                }
            ]
        },
        {
            "name": "Content",
            "sortOrder": 1,
            "properties": [
                {
                    "allowCultureVariant": false,
                    "alias": "bodyText",
                    "label": "Content",
                    "propertyEditorAlias": "Umbraco.TinyMCE",
                    "sortOrder": 0,
                    "validation": {
                        "required": false
                    }
                }
            ]
        },
        {
            "name": "Footer",
            "sortOrder": 2,
            "properties": [
                {
                    "allowCultureVariant": false,
                    "alias": "footerHeader",
                    "label": "Header",
                    "propertyEditorAlias": "Umbraco.TextBox",
                    "sortOrder": 0,
                    "validation": {
                        "required": false
                    }
                },
                {
                    "allowCultureVariant": false,
                    "alias": "footerDescription",
                    "label": "Description",
                    "propertyEditorAlias": "Umbraco.TextArea",
                    "sortOrder": 1,
                    "validation": {
                        "required": false
                    }
                },
                {
                    "allowCultureVariant": false,
                    "alias": "footerCTACaption",
                    "description": "Caption on the Call To Action Button",
                    "label": "Call to Action Caption",
                    "propertyEditorAlias": "Umbraco.TextBox",
                    "sortOrder": 2,
                    "validation": {
                        "required": false
                    }
                },
                {
                    "allowCultureVariant": false,
                    "alias": "footerCTALink",
                    "label": "Call to Action Link",
                    "propertyEditorAlias": "Umbraco.ContentPicker",
                    "sortOrder": 3,
                    "validation": {
                        "required": true
                    }
                },
                {
                    "allowCultureVariant": false,
                    "alias": "footerAddress",
                    "label": "Address",
                    "propertyEditorAlias": "Umbraco.TextBox",
                    "sortOrder": 4,
                    "validation": {
                        "required": true
                    }
                }
            ]
        },
        {
            "name": "Design",
            "sortOrder": 3,
            "properties": [
                {
                    "allowCultureVariant": false,
                    "alias": "heroBackgroundImage",
                    "configuration": {
                        "filter": null,
                        "multiple": false,
                        "validationLimit": {
                        "min": 0,
                        "max": 1
                        },
                        "startNodeId": null,
                        "enableLocalFocalPoint": false,
                        "crops": null,
                        "ignoreUserStartNodes": false
                    },
                    "description": "Spice up the homepage by adding a beautiful photo that relates to your business",
                    "label": "Hero Background",
                    "propertyEditorAlias": "Umbraco.MediaPicker3",
                    "sortOrder": 0,
                    "validation": {
                        "required": true
                    }
                },
                {
                    "allowCultureVariant": false,
                    "alias": "font",
                    "configuration": {
                        "items": {
                            "1": {
                                "value": "Serif",
                                "sortOrder": 1
                            },
                            "2": {
                                "value": "Sans-serif",
                                "sortOrder": 2
                            }
                        }
                    },
                    "label": "Font",
                    "propertyEditorAlias": "Umbraco.RadioButtonList",
                    "sortOrder": 1,
                    "validation": {
                        "required": true
                    }
                },
                {
                    "allowCultureVariant": false,
                    "alias": "colorTheme",
                    "configuration": {
                        "items": {
                            "1": {
                                "value": "Red",
                                "sortOrder": 1
                            },
                            "2": {
                                "value": "Blue",
                                "sortOrder": 2
                            },
                            "3": {
                                "value": "Green",
                                "sortOrder": 3
                            }
                        }
                    },
                    "label": "Color Theme",
                    "propertyEditorAlias": "Umbraco.RadioButtonList",
                    "sortOrder": 2,
                    "validation": {
                        "required": true
                    }
                },
                {
                    "allowCultureVariant": false,
                    "alias": "sitename",
                    "description": "Used on the homepage as well as the title and social cards",
                    "label": "Sitename",
                    "propertyEditorAlias": "Umbraco.TextBox",
                    "sortOrder": 3,
                    "validation": {
                        "required": true
                    }
                },
                {
                    "allowCultureVariant": false,
                    "alias": "logo",
                    "configuration": {
                        "filter": null,
                        "multiple": false,
                        "validationLimit": {
                        "min": 0,
                        "max": 1
                        },
                        "startNodeId": null,
                        "enableLocalFocalPoint": false,
                        "crops": null,
                        "ignoreUserStartNodes": false
                    },
                    "description": "Optional. If you add a logo it'll be used in the upper left corner instead of the site name. Make sure to use a transparent logo for best results",
                    "label": "Logo",
                    "propertyEditorAlias": "Umbraco.MediaPicker3",
                    "sortOrder": 4,
                    "validation": {
                        "required": false
                    }
                }
            ]
        }
    ],
    "name": "Home",
    "_createDate": "2019-10-04T10:54:53.297Z",
    "_id": "0a87cb29-ba6e-4520-8ce6-85e70d89e539",
    "_updateDate": "2019-10-04T10:54:53.297Z",
    "_links": {
        "self": {
            "href": "https://api.umbraco.io/content/type/home"
        },
        "root": {
            "href": "https://api.umbraco.io/content/type"
        }
    }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.umbraco.com/umbraco-heartcore/api-documentation/content-management/content/type.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
